'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var XRegExp = require("xregexp");
var base_1 = require("./base");
var debug = require('debug')('Markdown');

var Markdown = function (_base_1$BaseMarkupMod) {
    _inherits(Markdown, _base_1$BaseMarkupMod);

    function Markdown(quill) {
        _classCallCheck(this, Markdown);

        // **text**
        var _this = _possibleConstructorReturn(this, (Markdown.__proto__ || Object.getPrototypeOf(Markdown)).call(this, quill));

        _this._bold = XRegExp(/(\*{2})[^\*\n]*?\1/gi);
        // *text*
        _this._italic = XRegExp(/(\*)[^\*\n]*?\1/gi);
        // _text_
        _this._underline = XRegExp(/(\_{1}).+?\1/gi);
        // ~text~
        _this._strikethrough = XRegExp(/(\~{1}).+?\1/gi);
        // `text`
        _this._mono = XRegExp(/(`{1})(?!\`).+?\1/gi);
        // > text
        _this._blockquote = XRegExp(/^>\s.*/gmi);
        // [text]
        _this._link1 = XRegExp(/(\[)([^\]]*)(\])(?![\[\(])/gi);
        // [text](link) or ![text](link)
        _this._link2 = XRegExp(/(!?\[)([^\]^\]\[^\]\]]*)(\]\()([^\]\)]*)(\))/gi);
        // [text][id] or ![text][id]
        _this._link3 = XRegExp(/(!?\[)([^\]^\]\[^\]\]]*)(\]\[)([^\]]*)(\])/gi);
        // [text]: [url] "title"
        _this._link4 = XRegExp(/(\[)([^\]^\]\[^\]\]]*)(\]\:\s+)([^\s]+)(\s+)("[^"]*?"){0,1}/gi);
        // + {text}
        // - {text}
        // * {text}
        // ##. {text}
        _this._list = XRegExp(/^\s*([\*\-\+]{1})[ \t]+|^\s*\w+\.[ \t]+/gmi);
        // # {text}
        _this._h1 = XRegExp(/^# .*/gmi);
        // ## {text}
        _this._h2 = XRegExp(/^## .*/gmi);
        // ### {text}
        _this._h3 = XRegExp(/^### .*/gmi);
        // #### {text}
        _this._h4 = XRegExp(/^#### .*/gmi);
        // ##### {text}
        _this._h5 = XRegExp(/^##### .*/gmi);
        // ###### {text}
        _this._h6 = XRegExp(/^###### .*/gmi);
        // {text}
        // ======
        _this._h1block = XRegExp(/.+(\r\n|\r|\n)==+/gi);
        // {text}
        // ------
        _this._h2block = XRegExp(/.+(\r\n|\r|\n)--+/gi);
        _this._hr = XRegExp(/^\-{3,}|^\*{3,}|^_{3,}/gmi);
        debug('creating markdown mode %o', quill);
        return _this;
    }

    _createClass(Markdown, [{
        key: "highlightInline",
        value: function highlightInline() {
            this.colorize(this.subText, this._blockquote, this.style.blockquote);
            this.colorize(this.subText, this._list, this.style.list);
            this.colorize(this.subText, this._italic, this.style.italic);
            this.colorize(this.subText, this._bold, this.style.bold);
            this.colorize(this.subText, this._strikethrough, this.style.strikethrough);
            this.colorize(this.subText, this._underline, this.style.underline);
            this.colorize(this.subText, this._hr, this.style.hr);
            this.colorize(this.subText, this._h1, this.style.h1);
            this.colorize(this.subText, this._h2, this.style.h2);
            this.colorize(this.subText, this._h3, this.style.h3);
            this.colorize(this.subText, this._h4, this.style.h4);
            this.colorize(this.subText, this._h5, this.style.h5);
            this.colorize(this.subText, this._h6, this.style.h6);
            this.colorizeLink(this.subText, this._link1);
            this.colorizeLink(this.subText, this._link2);
            this.colorizeLink(this.subText, this._link3);
            this.colorizeLink(this.subText, this._link4);
            this.colorize(this.subText, this._mono, this.style.mono);
            _get(Markdown.prototype.__proto__ || Object.getPrototypeOf(Markdown.prototype), "highlightInline", this).call(this);
        }
    }, {
        key: "highlightBlock",
        value: function highlightBlock() {
            this.colorizeBlock(this.text, this._h1block, this.style.h1);
            this.colorizeBlock(this.text, this._h2block, this.style.h2);
            _get(Markdown.prototype.__proto__ || Object.getPrototypeOf(Markdown.prototype), "highlightBlock", this).call(this);
        }
    }, {
        key: "handleBold",
        value: function handleBold() {
            this.annotateInline(this.selection, '**');
        }
    }, {
        key: "handleHeader",
        value: function handleHeader(level) {
            switch (level) {
                case 1:
                    this.annotateBlock(this.line, '#');
                    break;
                case 2:
                    this.annotateBlock(this.line, '##');
                    break;
                case 3:
                    this.annotateBlock(this.line, '###');
                    break;
                case 4:
                    this.annotateBlock(this.line, '####');
                    break;
                case 5:
                    this.annotateBlock(this.line, '#####');
                    break;
                case 6:
                    this.annotateBlock(this.line, '######');
                    break;
                case 0:
                default:
                    break;
            }
        }
    }, {
        key: "handleItalic",
        value: function handleItalic() {
            this.annotateInline(this.selection, '*');
        }
    }, {
        key: "handleStrikeThrough",
        value: function handleStrikeThrough() {
            this.annotateInline(this.selection, '~');
        }
    }, {
        key: "handleUnderline",
        value: function handleUnderline() {
            this.annotateInline(this.selection, '_');
        }
    }]);

    return Markdown;
}(base_1.BaseMarkupMode);

exports.Markdown = Markdown;